#pragma once

#include "Mix/Private/Graphics/Common/DeviceObject.h"
#include "Mix/Private/Graphics/DX9/Texture.h"

namespace Mix{ namespace Graphics{ namespace DX9{

	class Device;

	class TextureVolume : public Mix::Graphics::DX9::Texture, public Mix::Graphics::Common::DeviceObject
	{
		////////////////////////////////////////////////////////////////////////////////////////////////////
		// Mix::Graphics::DX9::TextureVolume
		////////////////////////////////////////////////////////////////////////////////////////////////////

	public:

		static TextureVolume* CreateInstance(	Mix::Graphics::DX9::Device* pDevice,
												const wchar_t* pFilePath,
												UInt32 width, UInt32 height, Mix::Graphics::FORMAT format,
												IDirect3DVolumeTexture9* pD3DTexture );

	private:
		Mix::Graphics::DX9::Device*	m_pDevice;

		Mix::String					m_FilePath;
		UInt32						m_Width;
		UInt32						m_Height;
		Mix::Graphics::FORMAT		m_Format;

		IDirect3DVolumeTexture9*	m_pD3DTexture;

	private:
		TextureVolume(	Mix::Graphics::DX9::Device* pDevice,
						const wchar_t* pFilePath,
						UInt32 width, UInt32 height, Mix::Graphics::FORMAT format,
						IDirect3DVolumeTexture9* pD3DTexture );

		virtual ~TextureVolume( void );

		////////////////////////////////////////////////////////////////////////////////////////////////////
		// Mix::Graphics::DeviceObject
		////////////////////////////////////////////////////////////////////////////////////////////////////

	public:
		virtual void Invalidate( void );
		virtual void Validate( void );

		////////////////////////////////////////////////////////////////////////////////////////////////////
		// Mix::Graphics::Texture
		////////////////////////////////////////////////////////////////////////////////////////////////////

	public:
		virtual IDirect3DBaseTexture9* GetInterface( void );
		virtual IDirect3DSurface9* GetSurface( UInt32 index );
		virtual UInt32 GetSurfaceCount( void ) const;

		////////////////////////////////////////////////////////////////////////////////////////////////////
		// Mix::Graphics::ITexture
		////////////////////////////////////////////////////////////////////////////////////////////////////

	public:
		virtual Mix::Graphics::ITexture::DIMENSION_TYPE GetDimensionType( void ) const;
		virtual Mix::Graphics::ITexture::BIND_TYPE GetBindType( void ) const;
		virtual UInt32 GetAccessFlags( void ) const;
		virtual Boolean Lock( Mix::Graphics::ITexture::LOCK& lock );
		virtual void Unlock( void );
		virtual UInt32 GetWidth( void ) const;
		virtual UInt32 GetHeight( void ) const;
		virtual Mix::Graphics::FORMAT GetFormat( void ) const;
		virtual const wchar_t* GetFilePath( void ) const;

		////////////////////////////////////////////////////////////////////////////////////////////////////
		// Mix::Graphics::IDeviceObject
		////////////////////////////////////////////////////////////////////////////////////////////////////

	public:
		virtual Mix::Graphics::IDeviceObject::TYPE GetType( void ) const;
	};

}}}
