#pragma once

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ̒`
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef WINVER
	//! @def WINVER
	//! @brief Windows̃o[W
	#define WINVER 0x0600	//WindowsVista ȍ~
#endif //WINVER

#ifndef _WIN32_WINNT
	//! @def _WIN32_WINNT
	//! @brief Windows̃o[W
	#define _WIN32_WINNT 0x0600	//WindowsVista ȍ~
#endif //_WIN32_WINNT

#ifndef _WIN32_IE
	//! @def _WIN32_IE
	//! @brief IẼo[W
	#define _WIN32_IE 0x560		//IE5.6ȍ~
#endif //_WIN32_IE

#ifndef STRICT
	//! @def STRICT
	//! @brief XgNg
	#define STRICT
#endif //STRICT

#ifndef DIRECTINPUT_VERSION
	//! @def DIRECTINPUT_VERSION
	//! @brief DirectInput̃o[W
	#define DIRECTINPUT_VERSION 0x800
#endif //DIRECTINPUT_VERSION

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CN[h
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <winsock2.h>
#include <ws2tcpip.h>
#include <winuser.h>
#include <typeinfo>
#include <memory>
#include <algorithm>
#include <time.h>
#include <math.h>
#include <mmsystem.h>
#include <mmreg.h>
#include <msacm.h>
#include <process.h>
#include <shlobj.h>
#include <Imm.h>
#include <list>
#include <vector>
#include <map>

#include <InitGuid.h>
#include <d3dcompiler.h>
#include <ddraw.h>
#include <d3d9.h>
#include <d3d11.h>
#include <dxgi.h>
#include <dinput.h>
#include <XInput.h>
#include <XAudio2.h>
#include <X3daudio.h>

#include "btBulletDynamicsCommon.h"
#include "BulletWorldImporter/btBulletWorldImporter.h"
#include "BulletCollision/CollisionDispatch/btGhostObject.h"
#include "BulletDynamics/Character/btKinematicCharacterController.h"

#include "Mix/Standard.h"
#include "Mix/Private/Logger.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// }N
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Mix ̃ǗgpÅmہA //

#define MIX_LIB_MALLOC( section, size ) Mix::Memory::Allocate( section, size, __FILEW__, __LINE__ )
#define MIX_LIB_MALLOC_T( section, T, count ) static_cast<T*>( Mix::Memory::Allocate( section, sizeof( T ) * count, __FILEW__, __LINE__ ) )
#define MIX_LIB_ALIGNED_MALLOC( section, alignment, size ) Mix::Memory::AllocateAligned( section, alignment, size, __FILEW__, __LINE__ )
#define MIX_LIB_ALIGNED_MALLOC_T( section, alignment, T, count ) static_cast<T*>( Mix::Memory::Allocate( section, alignment, sizeof( T ) * count, __FILEW__, __LINE__ ) )
#define MIX_LIB_FREE( ptr ) if( ptr != NULL ) { Mix::Memory::Free( ptr, __FILEW__, __LINE__ ); ptr = NULL; }

#define MIX_LIB_REALLOC( ptr, size ) Mix::Memory::Reallocate( ptr, size, __FILEW__, __LINE__ )
#define MIX_LIB_REALLOC_T( ptr, T, count ) static_cast<T*>( Mix::Memory::Reallocate( ptr, sizeof( T ) * count ), __FILEW__, __LINE__ )

// Mix ̃ǗgpACX^X̍쐬A폜 //

#define MIX_LIB_NEW_T( section, T, ... ) new( section, __FILEW__, __LINE__ ) T( __VA_ARGS__ )
#define MIX_LIB_ALIGNED_NEW_T( section, align, T, ... ) new( section, align, __FILEW__, __LINE__ ) T( __VA_ARGS__ )

#define MIX_LIB_DELETE_T( T, ptr ) \
	if( ptr != NULL ) \
	{ \
		ptr->~T(); \
		Mix::Memory::Free( ptr, __FILEW__, __LINE__ ); \
		ptr = NULL; \
	}

#define MIX_LIB_DELETE_THIS_T( T, ptr ) \
	ptr->~T(); \
	Mix::Memory::Free( ptr, __FILEW__, __LINE__ );

// Mix ̃ǗgpACX^Xz̍쐬A폜 //

#define MIX_LIB_NEW_ARRAY_T( section, T, count ) new( section, __FILEW__, __LINE__ ) T[count]
#define MIX_LIB_ALIGNED_NEW_ARRAY_T( section, align, T, count ) new( section, align, __FILEW__, __LINE__ ) T[count]

#define MIX_LIB_DELETE_ARRAY_T( T, ptr ) MIX_DELETE_ARRAY_T( T, ptr )
#define MIX_LIB_DELETE_PTR_ARRAY_T( ptr ) MIX_DELETE_PTR_ARRAY_T( ptr )

// p̃ǗĂ郉Cu ( Bullet Ȃ ) Ȃǂ́ACX^X̍쐬A폜 //

#define MIX_LIB_NEW new

#define MIX_LIB_DELETE( ptr ) \
	if( ptr != NULL ) \
	{ \
		delete ptr; \
		ptr = NULL; \
	}

#define MIX_LIB_DELETE_THIS( ptr ) delete ptr

#define MIX_LIB_DELETE_ARRAY( ptr ) \
	if( ptr != NULL ) \
	{ \
		delete [] ptr; \
		ptr = NULL; \
	}

//\̃oւ̃ItZbg擾
#define MIX_OFFSETOF( Class, Value ) static_cast<UInt16>( offsetof( Class, Value ) )

//l[ NULL nȂ悤ɂ邽߂̒`
//#define MIX_SAFE_NAME( name ) ( name != NULL )? name : L"UNKNOWN"
#define MIX_SAFE_NAME( name ) ( ( name == NULL ) || ( wcslen( name ) == 0 ) )? Mix::STR_UNKNOWN : name

//̒擾
#define MIX_STR_LENGTH( str ) ( ( str != NULL )? ::wcslen( str ) : 0 )
//NULLłԂ悤
#define MIX_SAFE_STR( str ) ( ( str != NULL )? str : L"" )

//O : T|[g
#define MIX_LOG_STR( str ) ( str != NULL )? str : L"NULL"	//
#define MIX_LOG_PTR( ptr ) ( ptr != NULL )? L"" : L"~"	//|C^
#define MIX_LOG_BOOLEAN( state ) ( ( state ) == True )? L"" : L"~"	//Boolean

//O : 
#ifdef _DEBUG
	#define MIX_LOG_INFO( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_INFO, 0, format, __VA_ARGS__ )
	#define MIX_LOG_INFO_NO( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_INFO, Mix::Logger::F_NO_OVERLAP, format, __VA_ARGS__ )
	#define MIX_LOG_INFO_SL_NO() Logger::Instance()->WriteSectionLine( Mix::Logger::L_INFO, Mix::Logger::F_NO_OVERLAP );
	#define MIX_LOG_INFO_SECT_START( format, ... ) Logger::Instance()->WriteSctionStart( Mix::Logger::L_INFO, Mix::Logger::F_NO_OVERLAP, format, __VA_ARGS__ )
	#define MIX_LOG_INFO_SECT_END() Logger::Instance()->WriteSctionEnd( Mix::Logger::L_INFO, Mix::Logger::F_NO_OVERLAP )
#else //_DEBUG
	#define MIX_LOG_INFO( format, ... )
	#define MIX_LOG_INFO_NO( format, ... )
	#define MIX_LOG_INFO_SL_NO()
	#define MIX_LOG_INFO_SECT_START( format, ... )
	#define MIX_LOG_INFO_SECT_END()
#endif //_DEBUG

//O : ( [Xło͂ )
#define MIX_LOG_INFO_F( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_INFO_FORCE, 0, format, __VA_ARGS__ )
#define MIX_LOG_INFO_F_NO( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_INFO_FORCE, Mix::Logger::F_NO_OVERLAP, format, __VA_ARGS__ )
#define MIX_LOG_INFO_F_SL_NO() Logger::Instance()->WriteSectionLine( Mix::Logger::L_INFO_FORCE, Mix::Logger::F_NO_OVERLAP );
#define MIX_LOG_INFO_F_SECT_START( format, ... ) Logger::Instance()->WriteSctionStart( Mix::Logger::L_INFO_FORCE, 0, format, __VA_ARGS__ )
#define MIX_LOG_INFO_F_SECT_END() Logger::Instance()->WriteSctionEnd( Mix::Logger::L_INFO_FORCE, 0 )

//O : x
#define MIX_LOG_WARNING( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_WARNING, 0, format, __VA_ARGS__ )
#define MIX_LOG_WARNING_NO( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_WARNING, Mix::Logger::F_NO_OVERLAP, format, __VA_ARGS__ )
#define MIX_LOG_WARNING_SL_NO() Logger::Instance()->WriteSectionLine( Mix::Logger::L_WARNING, Mix::Logger::F_NO_OVERLAP );
#define MIX_LOG_WARNING_SECT_START( format, ... ) Logger::Instance()->WriteSctionStart( Mix::Logger::L_WARNING, 0, format, __VA_ARGS__ )
#define MIX_LOG_WARNING_SECT_END() Logger::Instance()->WriteSctionEnd( Mix::Logger::L_WARNING, 0 )

//O : G[
#define MIX_LOG_ERROR( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_ERROR, 0, format, __VA_ARGS__ )
#define MIX_LOG_ERROR_NO( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_ERROR, Mix::Logger::F_NO_OVERLAP, format, __VA_ARGS__ )
#define MIX_LOG_ERROR_SL_NO() Logger::Instance()->WriteSectionLine( Mix::Logger::L_ERROR, Mix::Logger::F_NO_OVERLAP );
#define MIX_LOG_ERROR_SECT_START( format, ... ) Logger::Instance()->WriteSctionStart( Mix::Logger::L_ERROR, 0, format, __VA_ARGS__ )
#define MIX_LOG_ERROR_SECT_END() Logger::Instance()->WriteSctionEnd( Mix::Logger::L_ERROR, 0 )

#ifdef _MIX_DEVELOP

	//O : (DEVELOP)
	#define MIX_LOG_DEV_INFO( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_INFO, Mix::Logger::F_DEVELOP, format, __VA_ARGS__ )
	#define MIX_LOG_DEV_INFO_NO( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_INFO, Mix::Logger::F_DEVELOP | Mix::Logger::F_NO_OVERLAP, format, __VA_ARGS__ )
	#define MIX_LOG_DEV_INFO_SL_NO() Logger::Instance()->WriteSectionLine( Mix::Logger::L_INFO, Mix::Logger::F_DEVELOP | Mix::Logger::F_NO_OVERLAP );
	#define MIX_LOG_DEV_INFO_SECT_START( format, ... ) Logger::Instance()->WriteSctionStart( Mix::Logger::L_INFO, Mix::Logger::F_DEVELOP, format, __VA_ARGS__ )
	#define MIX_LOG_DEV_INFO_SECT_END() Logger::Instance()->WriteSctionEnd( Mix::Logger::L_INFO, Mix::Logger::F_DEVELOP )

	//O : x(DEVELOP)
	#define MIX_LOG_DEV_WARNING( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_WARNING, Mix::Logger::F_DEVELOP, format, __VA_ARGS__ )
	#define MIX_LOG_DEV_WARNING_NO( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_WARNING, Mix::Logger::F_DEVELOP | Mix::Logger::F_NO_OVERLAP, format, __VA_ARGS__ )
	#define MIX_LOG_DEV_WARNING_SL_NO() Logger::Instance()->WriteSectionLine( Mix::Logger::L_WARNING, Mix::Logger::F_DEVELOP | Mix::Logger::F_NO_OVERLAP );
	#define MIX_LOG_DEV_WARNING_SECT_START( format, ... ) Logger::Instance()->WriteSctionStart( Mix::Logger::L_WARNING, Mix::Logger::F_DEVELOP, format, __VA_ARGS__ )
	#define MIX_LOG_DEV_WARNING_SECT_END() Logger::Instance()->WriteSctionEnd( Mix::Logger::L_WARNING, Mix::Logger::F_DEVELOP )

	//O : G[(DEVELOP)
	#define MIX_LOG_DEV_ERROR( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_ERROR, Mix::Logger::F_DEVELOP, format, __VA_ARGS__ )
	#define MIX_LOG_DEV_ERROR_NO( format, ... ) Logger::Instance()->WriteText( Mix::Logger::L_ERROR, Mix::Logger::F_DEVELOP | Mix::Logger::F_NO_OVERLAP, format, __VA_ARGS__ )
	#define MIX_LOG_DEV_ERROR_SL_NO Logger::Instance()->WriteSectionLine( Mix::Logger::L_ERROR, Mix::Logger::F_DEVELOP | Mix::Logger::F_NO_OVERLAP )
	#define MIX_LOG_DEV_ERROR_SECT_START( format, ... ) Logger::Instance()->WriteSctionStart( Mix::Logger::L_ERROR, Mix::Logger::F_DEVELOP, format, __VA_ARGS__ )
	#define MIX_LOG_DEV_ERROR_SECT_END() Logger::Instance()->WriteSctionEnd( Mix::Logger::L_ERROR, Mix::Logger::F_DEVELOP )

#else //_MIX_DEVELOP

	//O : (DEVELOP)
	#define MIX_LOG_DEV_INFO( format, ... )
	#define MIX_LOG_DEV_INFO_NO( format, ... )
	#define MIX_LOG_DEV_INFO_SL_NO()
	#define MIX_LOG_DEV_INFO_SECT_START( format, ... )
	#define MIX_LOG_DEV_INFO_SECT_END()

	//O : x(DEVELOP)
	#define MIX_LOG_DEV_WARNING( format, ... )
	#define MIX_LOG_DEV_WARNING_NO( format, ... )
	#define MIX_LOG_DEV_WARNING_SL_NO()
	#define MIX_LOG_DEV_WARNING_SECT_START( format, ... )
	#define MIX_LOG_DEV_WARNING_SECT_END()

	//O : G[(DEVELOP)
	#define MIX_LOG_DEV_ERROR( format, ... )
	#define MIX_LOG_DEV_ERROR_NO( format, ... )
	#define MIX_LOG_DEV_ERROR_SL_NO
	#define MIX_LOG_DEV_ERROR_SECT_START
	#define MIX_LOG_DEV_ERROR_SECT_END()

#endif //_MIX_DEVELOP

//O : i
#define MIX_LOG_PAR_PLUS() Logger::Instance()->Par( +1 )
#define MIX_LOG_PAR_MINUS() Logger::Instance()->Par( -1 )

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// `
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

namespace Mix
{
	class Engine;

	//G[
	enum ERR
	{
		ERR_GRAPHICS_DRIVERERROR	= 0,	//OtBbNX : OtBbNXhCoŃG[( I )
		ERR_GRAPHICS_CHANGEMODE		= 1,	//OtBbNX : [h̕ύXɎs( I )
	};

	//\EBhEbZ[W
	enum WINDOWMESSAGE
	{
		WM_MIX_INTERNALERROR = ( WM_APP + 100 ), //MixCu̓G[bZ[W( wParam G[^Cv(ERR) lParam Iꍇ True )
	};

	//[U[`
	static const wchar_t* DEF_USERDIRECTORYNAME = L"mix\\";			//ftHg̃[U[tH_
	static const wchar_t* SYSTEM_FILENAME = L"mix_system.txt";		//VXet@C
	static const wchar_t* LOG_FILENAME = L"mix_log.txt";			//Ot@C

	//񃊃\[X
	static const wchar_t* STR_ILLEGALARG = L"sȈn܂";
	static const wchar_t* STR_ERR_NOT_SUPPORT_VERSION = L"̃o[W̓T|[gĂ܂";
	static const wchar_t* STR_ILLEGALFORMAT = L"t@CtH[}bgsł";
	static const wchar_t* STR_FORMAT_NOT_SUPPORT = L"w肳ꂽtH[}bg̓T|[gĂ܂"; 
	static const wchar_t* STR_FILE_FORMAT_NOT_SUPPORT = L"w肳ꂽt@CtH[}bg̓T|[gĂ܂"; 
	static const wchar_t* STR_TYPE_NOT_SUPPORT = L"w肳ꂽ^Cv̓T|[gĂ܂"; 
	static const wchar_t* STR_OUTOFMEMORY = L"VXesĂ܂";
	static const wchar_t* STR_FILENOTFOUND = L"t@C܂";
	static const wchar_t* STR_RETERROR = L"G[Ԃ܂";
	static const wchar_t* STR_UNUSABLE = L"͎gpł܂";
	static const wchar_t* STR_INITERROR = L"ɃG[܂";
	static const wchar_t* STR_NULL = L"";
	static const wchar_t* STR_UNKNOWN = L"s";
	static const wchar_t* STR_ERROR = L"G[";
	static const wchar_t* STR_CAPACITY = L"Capacity";
	static const wchar_t* STR_TYPE = L"Type";
	static const wchar_t* STR_NAME = L"Name";
	static const wchar_t* STR_FORMAT = L"Format";
	static const wchar_t* STR_RESULT = L"Result";
	static const wchar_t* STR_DEBUGNAME = L"DebugName";
	static const wchar_t* STR_DIRPATH = L"DirectoryPath";
	static const wchar_t* STR_FILEPATH = L"FilePath";
	static const wchar_t* STR_FILENAME = L"FileName";
	static const wchar_t* STR_WIDTH = L"Width";
	static const wchar_t* STR_HEIGHT = L"Height";
	static const wchar_t* STR_SIZE = L"Size";

	HINSTANCE GetInternalInstanceHandle( void );

	Mix::Engine* GetInternalEnginePtr( void );
};

//
namespace Mix{ namespace Memory{

	static const UInt32 SECTION_TYPE_MAX = SECTION_USER + 1;

}}

//o
namespace Mix{ namespace IO{

	class Manager;

	static const UInt32 DIRECTORY_IDENT_MAX = 5; //fBNgʎq̍ő吔

	Mix::IO::Manager* GetInternalManagerPtr( void );
}}

//q[}C^[tF[XfoCX
namespace Mix{ namespace HID{

	class Manager;

	static const UInt32 DI_POV_MAX = 8;
	static const UInt32 DI_BUTTON_MAX = 32;
	static const UInt32 DI_BUTTON_MIN = 10;
	static const UInt32 DI_AXIS_MAX = 28;
	static const UInt32 DI_AXIS_MIN = 4;

	struct DI_GAMEPAD_DATA
	{
		UInt8 buttons[DI_BUTTON_MAX];
		Int32 axis[DI_AXIS_MAX];
		UInt32 pov;
	};

	static const UInt32 GAMEPAD_FINGER_MAX = 2;

	Mix::HID::Manager* GetInternalManagerPtr( void );
}}

//_Ci~NX
namespace Mix{ namespace Dynamics{

	class Manager;

	static const Mix::Dynamics::MATERIAL DEF_MATERIAL; //ftHg}eA
	static const UInt32 JOINT_TYPE_MAX = 5; //WCg^Cv̍ő
	static const UInt32 OBJECT_TYPE_MAX = 6; //IuWFNg^Cv̍ő
	static const UInt32 RB_STATUS_MAX = 3;	//Wbh{fB̃Xe[^X̍ő
	static const UInt32 DDC_MAX = 9; //fobO`F̍ő

	static const UInt32 LCPS_MIN_ITE = 4;  // LCP \o[̍ŏ
	static const UInt32 LCPS_MAX_ITE = 20; // LCP \o[̍ő唽

	static const Float32 CCD_MIN_PENE	= 0.0001f; // CCD ylg[V̍ŏl

	Mix::Dynamics::Manager* GetInternalManagerPtr( void );

}}

//OtBbNX
namespace Mix{ namespace Graphics{

	namespace Common
	{
		class Manager;
	}

	static const UInt32 SHADER_MODEL_MAX			= 3;	//VF[_[f̍ő吔
	static const UInt32 SHADER_TARGET_MAX			= 16;	//VF[_[^[Qbg̍ő吔
	static const UInt32 TARGET_MAX					= 4;	//^[Qbgő吔
	static const UInt32 VERTEX_ELEMENT_SEMANTIC_MAX	= 9;	//o[ebNXGg̃Z}eBbN^Cv̍ő吔
	static const UInt32 VERTEX_ELEMENT_FORMAT_MAX	= 14;	//o[ebNXGg̃tH[}bg̍ő吔
	static const UInt32 FILL_MAX					= 2;	//tB[hő吔
	static const UInt32 CULL_MAX					= 3;	//JO[hő吔
	static const UInt32 BLEND_MAX					= 6;	//uh[hő吔
	static const UInt32 COLOR_WRITE_MASK_MAX		= 3;	//J[݃}XNő吔
	static const UInt32 ZFUNC_MAX					= 8;	//Zt@NVő吔
	static const UInt32 TEXTURESTAGE_MAX			= 8;	//eNX`Xe[Wő吔
	static const UInt32 TEXTUREFILTER_MAX			= 3;	//eNX`tB^ő吔
	static const UInt32 TEXTUREADDRESS_MAX			= 2;	//eNX`[W̉@̍ő吔
	static const UInt32 CUBEMAP_FACE_MAX			= 6;	//L[u}bṽtFCXő吔
	static const UInt32 FMT_MAX						= 15;	//tH[}bgő吔
	static const UInt32 PT_MAX						= 5;	//v~eBu^Cv
	static const UInt32 QT_MAX						= 2;	//NG^Cv
	static const UInt32 IT_MAX						= 2;	//CfbNX^Cv

	//VF[_[^[Qbge[u
	static const char* SHADER_TARGET_TABLE[Mix::Graphics::SHADER_TARGET_MAX] =
	{
		"vs_3_0",
		"ps_3_0",

		"cs_4_0",
		"gs_4_0",
		"vs_4_0",
		"ps_4_0",

		"cs_4_1",
		"gs_4_1",
		"vs_4_1",
		"ps_4_1",

		"cs_5_0",
		"ds_5_0",
		"gs_5_0",
		"hs_5_0",
		"vs_5_0",
		"ps_5_0",
	};

	Mix::Graphics::Common::Manager* GetInternalManagerPtr( void );

}}

//OtBbNX( [eBeB )
namespace Mix{ namespace Graphics{ namespace Utility{

	static const UInt32 MATERIAL_TRANSPARENCY_MAX		= 2;	//\bh̍ő吔
	static const UInt32 MOTION_DRIVE_AXIS_MAX			= 3;	//[VhCu̍ő吔
	static const UInt32 SCENE_TYPE_MAX					= 1;	//V[^Cv̍ő吔
	static const UInt32 SCENE_RENDERING_QUALITY_MAX		= 3;	//V[̃_Oiő吔
	static const UInt32 SCENE_SHADOW_QUALITY_MAX		= 3;	//V[̉eiő吔
	static const UInt32 SCENE_POSTEFFECT_QUALITY_MAX	= 3;	//V[̃|XgGtFNgiő吔

}}}

//TEh
namespace Mix{ namespace Sound{

	class Manager;

	Mix::Sound::Manager* GetInternalManagerPtr( void );

}}

//
namespace Mix{ namespace Parallel{

	class Manager;

	Mix::Parallel::Manager* GetInternalManagerPtr( void );
}}

//V[
namespace Mix{ namespace Scene{

	namespace Common
	{
		class Manager;
	}

	//_Ci~NX : tB^[\
	struct DYNAMICS_FILTER
	{
		UInt16 group;	//O[v
		UInt16 mask;	//}XN
	};

	static const UInt32 MATERIAL_TRANSPARENCY_MAX		= 2;			//\bh̍ő吔

	static const UInt32 WCR_MAX							= 4;			//EH[^[茋ʂ̍ő吔

	static const UInt32 DKC_MAX							= 2;			//Ll}eBbNLN^[̃[h

	static const Float32 BRIGHT_PASS_MIN_OFFSET			= 0.0001f;		//uCgpX : ŏ̃ItZbg

	static const Int32 KS_BLUR_MIN_ITERATION			= 1;			//J[lTCYw肷^Cṽu[̍ŏJԂ
	static const Int32 KS_BLUR_MAX_ITERATION			= 16;			//J[lTCYw肷^Cṽu[̍őJԂ

	static const Float32 GAUSSIAN_BLUR_MIN_DISPERSION	= 000.0001f;	//KEVAu[̍ŏUl
	static const Float32 GAUSSIAN_BLUR_MAX_DISPERSION	= 128.0000f;	//KEVAu[̍ő啪Ul
	static const Int32 GAUSSIAN_BLUR_EX_MIN_RADIUS		= 4;			//KEVAu[EX̍ŏa
	static const Int32 GAUSSIAN_BLUR_EX_MAX_RADIUS		= 64;			//KEVAu[EX̍ő唼a

	static const UInt32 DDC_DYNAMICS_FIRST				= 0;			//fobO : `F : _Ci~NX̍ŏ
	static const UInt32 DDC_DYNAMICS_LAST				= 8;			//fobO : `F : _Ci~NX̍Ō
	static const UInt32 DDC_MAX							= 21;			//fobO : `F : ő吔

	static const wchar_t* STR_DISABLED_DYNAMICS			= L"_Ci~NXɂȂĂ܂B";

	Mix::Scene::Common::Manager* GetInternalManagerPtr( void );

}}

//vOC
namespace Mix{ namespace Plugin{

	static const UInt32 TYPE_MAX = 3;	//vOC̃^Cv( [0]͎gpĂȂ )

}}

//STL ( Mix ̃Ǘgp List Vector Map ̒` )
namespace Mix{ namespace STL{

	template<Mix::Memory::SECTION_TYPE ST, typename T>
	using List = std::list<T, Mix::Memory::STLAllocator<ST, T>>;

	template<Mix::Memory::SECTION_TYPE ST, typename T>
	using Vector = std::vector<T, Mix::Memory::STLAllocator<ST, T>>;

	template<Mix::Memory::SECTION_TYPE ST, typename KT, typename VT>
	using Map = std::map<KT, VT, std::less<KT>, Mix::Memory::STLAllocator<ST, std::pair<const KT, VT>>>;

	template<Mix::Memory::SECTION_TYPE ST, typename VT>
	Boolean Vector_Contains( const std::vector<VT, Mix::Memory::STLAllocator<ST, VT>>& vector, VT const value )
	{
		return ( std::find( vector.begin(), vector.end(), value ) != vector.end() );
	}

	template<Mix::Memory::SECTION_TYPE ST, typename VT>
	void Vector_FirstErase( std::vector<VT, Mix::Memory::STLAllocator<ST, VT>>& vector,
							size_t index )
	{
		MIX_ASSERT( vector.size() > index );

		size_t lastIndex = vector.size() - 1;

		if( lastIndex > 0 )
		{
			VT temp = vector[index];
			vector[index] = vector[lastIndex];
			vector[lastIndex] = temp;
		}

		vector.pop_back();
	}

	template<Mix::Memory::SECTION_TYPE ST, typename VT>
	void Vector_FirstErase( std::vector<VT, Mix::Memory::STLAllocator<ST, VT>>& vector,
							typename std::vector<VT, Mix::Memory::STLAllocator<ST, VT>>::iterator& it )
	{
		MIX_ASSERT( vector.size() > 0 );

		size_t index = std::distance( vector.begin(), it );
		size_t lastIndex = vector.size() - 1;

		MIX_ASSERT( index <= lastIndex );

		if( lastIndex > 0 )
		{
			VT temp = vector[index];
			vector[index] = vector[lastIndex];
			vector[lastIndex] = temp;
		}

		vector.pop_back();
	}

	template<Mix::Memory::SECTION_TYPE ST, typename VT>
	Boolean Vector_FirstErase(	std::vector<VT, Mix::Memory::STLAllocator<ST, VT>>& vector,
								VT value )
	{
		size_t count = vector.size();
		if( count == 0 )
		{
			return False;
		}

		size_t lastIndex = vector.size() - 1;
		if( lastIndex > 0 )
		{
			std::vector<VT, Mix::Memory::STLAllocator<ST, VT>>::iterator it = std::find( vector.begin(), vector.end(), value );

			if( it != vector.end() )
			{
				size_t index = std::distance( vector.begin(), it );

				VT tempValue = vector[index];
				vector[index] = vector[lastIndex];
				vector[lastIndex] = tempValue;
			}
			else
			{
				return False;
			}
		}

		vector.pop_back();

		return True;
	}

}}
